#include <stdio.h>
#include <stdlib.h>

// https://stackoverflow.com/questions/7666509/hash-function-for-string/45641002#45641002
// I've had nice results with djb2 by Dan Bernstein.

unsigned long
hash(unsigned char *str)
{
	unsigned long hash = 5381;
	int c;

	while( (c = *str++ ) )
		hash = ((hash << 5) + hash) + c; /* hash * 33 + c */

	return hash;
}

int main( )
{
	//  5 pares                llave - dato
	char * palabras[5][2] = { {"aaa", "Primero"},
	                          {"aba", "Segundo"},
	                          {"baa", "Tercero"},
	                          {"Aaa", "Cuarto"},
	                          {"AAa", "Quinto"} };
	char *tabla[10];
	int i;
	unsigned long v;
	int indice;

	for( i=0; i<10; i++ )
		tabla[i] = NULL;

	for( i=0; i<5; i++ ) {
		v = hash( (unsigned char *)palabras[i][0] );
		indice = (int)(v%10);
		tabla[indice] = palabras[i][1];
		printf( "%ld %s %d %s\n", v, palabras[i][0], indice, tabla[indice] );
	}

	printf("Busco \"baa\"\n" );
	v = hash( (unsigned char *)"baa" );
	indice = (int)(v%10);
	if( tabla[ indice ] != NULL ) {
		printf( "¡Existe!\n" );
		printf( "Es: %s\n", tabla[ indice ] );
	} 
	return 0;
}
